<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="80px"
    >
      <el-form-item label="申请日期">
        <el-date-picker
          v-model="searchDate"
          type="daterange"
          value-format="yyyy-MM-dd HH:mm:ss"
          align="left"
          unlink-panels
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          clearable
          size="small"
          style="width: 260px; "
          :default-time="['00:00:00', '23:59:59']"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label="个体户ID" prop="merchantId">
        <el-input
          v-model="queryParams.merchantId"
          placeholder="请输入商户ID"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="phonenumber">
        <el-input
          v-model="queryParams.phonenumber"
          placeholder="请输入店铺名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="服务主题" prop="goodsName">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入服务主题"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="服务类型">
        <el-cascader
          :options="categoryList"
          :props="optionProps"
          size="small"
          clearable
          @change="handleCategory"
        ></el-cascader>
      </el-form-item>
      <el-form-item label="状态">
        <el-select
          v-model="queryParams.isSale"
          placeholder="请选择"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        >
          <el-option label="全部" value></el-option>
          <el-option label="未上架" value="0"></el-option>
          <el-option label="已上架" value="1"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="small"
          icon="el-icon-search"
          @click="handleQuery"
          plain
        >搜索</el-button>
        <el-button icon="el-icon-refresh" size="small" @click="resetQuery"
        >重置</el-button>

      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="pageList" border stripe>
      <el-table-column label="个体户id" align="center" prop="merchantId" width="120" />
      <el-table-column
        label="手机号"
        align="center"
        prop="phonenumber"
        show-overflow-tooltip
      />
      <el-table-column
        label="服务ID"
        align="center"
        prop="goodsId"
        show-overflow-tooltip
      />
      <el-table-column
        label="服务主题"
        align="center"
        prop="name"
        show-overflow-tooltip
      />
      <el-table-column
        label="服务类型"
        align="center"
        prop="categoryName"
        width="150"
      />
      <el-table-column
        label="服务人员数"
        align="center"
        prop="serverUserCount"
        width="150"
      />

      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        width="160"
      >
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="businessState">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.isSale == '1'" type="success">
            已上架</el-tag
          >
          <el-tag v-if="scope.row.isSale == '0'" type="info">
            未上架</el-tag
          >
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" width="220" fixed="right">
        <template slot-scope="scope">
          <el-button
            type="text"
            icon="el-icon-view"
            @click="queryDetails(scope.row.goodsId)"
            v-hasPermi="['shop:audit:detail']"
          >查看详情
          </el-button>
          <el-button
            type="text"
            icon="el-icon-bottom"
            @click="takeOff(scope.row)"
            v-hasPermi="['shop:audit:audit']"
            v-if="scope.row.isSale == '1'"
          >下架
          </el-button>
          <el-button
            type="text"
            icon="el-icon-top"
            @click="takeOn(scope.row)"
            v-hasPermi="['shop:audit:audit']"
            v-if="scope.row.isSale == '0'"
          >上架
          </el-button>
          <el-button
            type="text"
            icon="el-icon-delete"
            @click="deleteGoods(scope.row)"
            v-hasPermi="['shop:audit:audit']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加下架原因信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form
        ref="form"
        :model="form"
        label-width="120px"
        style="height: 100px"
      >
        <el-input
          type="textarea"
          :rows="4"
          v-model="form.closeReason"
          placeholder="请输入下架的原因"
        />
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { goodsTakeOn, goodsTakeOff, goodsList, deleteGoods} from "@/api/merchant/adminMerchant";
import { categoryTree } from "@/api/basic/category";

export default {
  name: "adminMerchant",
  data() {
    return {
      merchantType: 1,
      showSearch: true,
      loading: true,
      total: 0,
      pageList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        phonenumber: "",
        name: "",
        isSale: '',
        categoryId: "",
        merchantId: "",
        beginTime: "",
        endTime: "",
        merchantType: ""
      },
      form: {},
      // 弹出层标题
      title: "",
      open: false,
      searchDate: "",
      categoryList: [],
      optionProps: {
        value: "categoryId",
        label: "categoryName",
        children: "childrenCategory"
      }
    };
  },
  created() {
    this.getList();
    this.categoryTree();
  },
  methods: {
    categoryTree() {
      categoryTree().then(res => {
        if (res.code == 200) {
          this.categoryList = res.data
        } else {
          this.$message.error("获取分类列表失败")
        }
        console.log(res)
      }).catch(err => {
        this.$message.error("获取分类列表失败")
        console.log(err)
      })
    },
    handleCategory(value) {
      console.log(value)
      this.queryParams.categoryId = value[value.length - 1]
      console.log(this.queryParams.categoryId)
    },
    /** 查询待审核列表 */
    getList() {
      this.loading = true;
      if(this.searchDate == null){
        this.searchDate = ''
      }
      const [searchBegin, searchEnd] = this.searchDate;
      let sBegin = searchBegin;
      let sEnd = searchEnd;
      if (typeof searchBegin == "undefined") {
        sBegin = "";
      }
      if (typeof searchEnd == "undefined") {
        sEnd = "";
      }
      this.queryParams.beginTime = sBegin;
      this.queryParams.endTime = sEnd;
      this.queryParams.merchantType = this.merchantType;
      goodsList(this.queryParams)
        .then((response) => {
          console.log(response)
          this.pageList = response.rows;
          this.total = parseInt(response.total);
        }).catch(err => {
        console.log(err)
      }).finally(() => {
        this.loading = false;
      });
    },
    // 表单重置
    reset() {
      this.form = {
        merchantId: null,
        examineReason: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.searchDate = [];
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
        phonenumber: "",
        merchantPhone: "",
        shopState: "",
        promoter: "",
        merchantId: "",
        merchantType: ""
      };
      this.handleQuery();
    },
    /**  查看详情 */
    queryDetails(primaryId) {
      this.$message.success("查看详情")
      // this.$router.push("/adminMerchant/pass/info?merchantId=" + primaryId);
    },

    /** 下架按钮操作 */
    takeOff(row) {
      const goodsId = row.goodsId;
      const name = row.name == null ? "" : row.name;
      this.$confirm(
        '确认下架服务: <span style="font-weight: bold">' +
        name +
        "</span> 吗?",
        "提示",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          dangerouslyUseHTMLString: true,
          type: "warning",
        }
      ).then(() => {
        goodsTakeOff({
          goodsId: goodsId
        }).then(res => {
          if (res.code == 200) {
            this.$message.success("上架成功！")
            this.getList();
          } else {
            this.$message.error("上架失败！")
          }
        }).catch(err => {
          this.$message.error("操作失败！")
        })
      }).catch(() => {

      });
    },

    takeOn(row) {
      const goodsId = row.goodsId;
      const name = row.name == null ? "" : row.name;
      this.$confirm(
        '确认上架服务: <span style="font-weight: bold">' +
        name +
        "</span> 吗?",
        "提示",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          dangerouslyUseHTMLString: true,
          type: "warning",
        }
      ).then(() => {
        goodsTakeOn({
          goodsId: goodsId
        }).then(res => {
          if (res.code == 200) {
            this.$message.success("上架成功！")
            this.getList();
          } else {
            this.$message.error("上架失败！")
          }
        }).catch(err => {
          this.$message.error("操作失败！")
        })
      }).catch(() => {

      });
    },

    deleteGoods(row) {
      const goodsId = row.goodsId;
      const name = row.name == null ? "" : row.name;
      this.$confirm(
        '确认删除服务: <span style="font-weight: bold">' +
        name +
        "</span> 吗?",
        "提示",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          dangerouslyUseHTMLString: true,
          type: "warning",
        }
      ).then(() => {
        deleteGoods(goodsId).then(res => {
          if (res.code == 200) {
            this.$message.success("删除成功！")
            this.getList();
          } else {
            this.$message.error("删除失败！")
          }
        }).catch(err => {
          this.$message.error("操作失败！")
        })
      }).catch(() => {

      });
    },

    /** 提交按钮 */
    submitForm() {
      if (this.form.closeReason == null ) {
        this.$message.error("下架原因不可为空")
        return;
      }
      if (this.form.merchantId != null) {
        takeOff(this.form).then(res => {
          if (res. code == 200) {
            this.$message.success("下架成功");
          } else {
            this.$message.error(res.msg)
          }
          this.open = false;
          this.getList();
          console.log(res)
        }).catch(err => {
          console.log(err)
          this.$message.error("操作失败")
        })

      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
  },
};
</script>

<style>
</style>
